/* Default access switch.
Changes default_access to 0, if admin is entering the server and back to 1 if the last admin disconnects. 
v1.0 by [WING]Black Knight, 5.6.2002
Small changes 7.5.2005, untested
*/


#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>
#define ACCESS_CONSOLE 131072

new STRING_VERSION[MAX_DATA_LENGTH] = "v1.0";

new admin = 0;

new Message0[MAX_TEXT_LENGTH]="Admin online!^nadmin_vote_kick, admin_vote_map^nand say rockthevote disabled";
new Message1[MAX_TEXT_LENGTH]="Admins offline!^nadmin_vote_kick, admin_vote_map^nand say rockthevote enabled";

public default_entered(HLCommand, HLData){
	new strUserIndex[MAX_TEXT_LENGTH];
	new strName[MAX_NAME_LENGTH];
	new iUser;
	new UserID;
	new Team;
	new Dead;
	new WONID;
	
	convert_string(HLData, strUserIndex, MAX_TEXT_LENGTH);
	
	iUser = strtonum(strUserIndex);
	
	playerinfo(iUser, strName, MAX_NAME_LENGTH, UserID, WONID, Team, Dead);
	
	if(access(ACCESS_MAP,strName)) 
	{
		typesay(Message0,12,255,255,255);
		if(admin==0)
		{
			setstrvar("default_access","0");
			plugin_exec("admin_reload","");
		}
		admin=1;
	}
	if(admin)
	{
		messageex(strName,Message0,print_chat);
	}
	else
	{
		messageex(strName,Message1,print_chat);
	}
	return PLUGIN_CONTINUE;
}

public default_disconnect(HLCommand, HLData){

	new strName[MAX_NAME_LENGTH];
	new UserID;
	new Team;
	new Dead;
	new WONID;
	new a=0;
	new i;
	new maxplayers=maxplayercount();
	
	for(i=1;i<=maxplayers;i++)
	{
		if(playerinfo(i, strName, MAX_NAME_LENGTH, UserID, WONID, Team, Dead)==1)
		{
			if(access(ACCESS_MAP,strName)) 
			{
				a=1;
				break;
			}
		}
	}
	if(!a)
	{	
		typesay(Message1,12,255,200,201);
		admin=0;
		setstrvar("default_access","1");
		plugin_exec("admin_reload","");
	}
		
	return PLUGIN_CONTINUE;
}

public plugin_init() {
	plugin_registerinfo("Default Access Switch","default_access switch while away",STRING_VERSION);
	plugin_registercmd("default_entered","default_entered",ACCESS_CONSOLE,"");
	plugin_registercmd("default_disconnect","default_disconnect",ACCESS_CONSOLE,"");

	exec("logd_reg 52 admin_command default_disconnect");
	exec("logd_reg 51 admin_command default_entered");

	return PLUGIN_CONTINUE;
}